package net.gui;

import java.util.ArrayList;
import java.util.List;

import net.controller.AppController;
import net.models.Etat;
import net.models.Fichefrais;

import org.eclipse.swt.widgets.Display;
import org.eclipse.swt.widgets.Shell;
import org.eclipse.swt.widgets.Group;
import org.eclipse.swt.SWT;
import org.eclipse.swt.widgets.Table;
import org.eclipse.swt.widgets.Label;
import org.eclipse.swt.widgets.Text;
import org.eclipse.swt.widgets.Combo;
import org.eclipse.swt.widgets.Button;
import org.eclipse.swt.events.MouseAdapter;
import org.eclipse.swt.events.MouseEvent;
import org.eclipse.core.databinding.observable.Realm;
import org.eclipse.jface.databinding.swt.SWTObservables;
import org.eclipse.jface.viewers.ComboViewer;
import org.eclipse.core.databinding.DataBindingContext;
import org.eclipse.jface.databinding.viewers.ObservableListContentProvider;
import org.eclipse.core.databinding.observable.map.IObservableMap;
import org.eclipse.core.databinding.beans.BeansObservables;
import org.eclipse.jface.databinding.viewers.ObservableMapLabelProvider;
import org.eclipse.core.databinding.observable.list.IObservableList;
import org.eclipse.core.databinding.property.Properties;

public class FicheFrais_edit {
	private DataBindingContext m_bindingContext;

	protected Shell shell;
	private Table table;
	private Text text;
	private Text text_1;
	private Text text_2;
	private Table table_1;
	private static List<Etat> listEtats = new ArrayList<>();
	private ComboViewer comboViewer;

	/**
	 * Launch the application.
	 * 
	 * @param args
	 */
	public static void main(String[] args) {
		Display display = Display.getDefault();
		Realm.runWithDefault(SWTObservables.getRealm(display), new Runnable() {
			public void run() {
				try {
					FicheFrais_edit window = new FicheFrais_edit();
					window.open();
				} catch (Exception e) {
					e.printStackTrace();
				}
			}
		});
	}

	/**
	 * Open the window.
	 */
	public void open() {
		Realm.runWithDefault(SWTObservables.getRealm(Display.getDefault()),
				new Runnable() {
					public void run() {
						
						AppController.initListEtats();
						listEtats = AppController.getListEtats();
						
						Display display = Display.getDefault();
						createContents();
						shell.open();
						shell.layout();
						while (!shell.isDisposed()) {
							if (!display.readAndDispatch()) {
								display.sleep();
							}
						}
					}
				});
	}

	/**
	 * Create contents of the window.
	 */
	protected void createContents() {
		shell = new Shell(Display.getDefault(), SWT.APPLICATION_MODAL
				| SWT.CLOSE);
		shell.setSize(690, 412);
		shell.setText("Fiche de Frais");

		Group group = new Group(shell, SWT.NONE);
		group.setText("Lignes frais forfait");
		group.setBounds(10, 126, 337, 173);

		table = new Table(group, SWT.BORDER | SWT.FULL_SELECTION);
		table.setLinesVisible(true);
		table.setHeaderVisible(true);
		table.setBounds(10, 27, 313, 136);

		Group group_1 = new Group(shell, SWT.NONE);
		group_1.setText("Fiche de frais");
		group_1.setBounds(10, 10, 337, 110);

		Label label = new Label(group_1, SWT.NONE);
		label.setText("Visiteur");
		label.setBounds(10, 26, 59, 14);

		Label label_1 = new Label(group_1, SWT.NONE);
		label_1.setText("Montant");
		label_1.setBounds(10, 46, 59, 14);

		Label label_2 = new Label(group_1, SWT.NONE);
		label_2.setText("Mois");
		label_2.setBounds(10, 66, 59, 14);

		Label label_3 = new Label(group_1, SWT.NONE);
		label_3.setText("Etat");
		label_3.setBounds(10, 86, 59, 14);

		text = new Text(group_1, SWT.BORDER);
		text.setBounds(229, 23, 94, 19);

		text_1 = new Text(group_1, SWT.BORDER);
		text_1.setBounds(229, 43, 94, 19);

		text_2 = new Text(group_1, SWT.BORDER);
		text_2.setBounds(229, 63, 94, 19);

		comboViewer = new ComboViewer(group_1, SWT.READ_ONLY);
		Combo combo = comboViewer.getCombo();
		combo.setBounds(229, 83, 94, 14);

		Group group_2 = new Group(shell, SWT.NONE);
		group_2.setText("Lignes frais hors-forfait");
		group_2.setBounds(349, 126, 337, 173);

		table_1 = new Table(group_2, SWT.BORDER | SWT.FULL_SELECTION);
		table_1.setLinesVisible(true);
		table_1.setHeaderVisible(true);
		table_1.setBounds(10, 27, 313, 136);

		Group group_3 = new Group(shell, SWT.NONE);
		group_3.setBounds(10, 305, 676, 48);

		Button button = new Button(group_3, SWT.NONE);
		button.setText("Valider");
		button.setBounds(10, 10, 94, 28);

		Button button_1 = new Button(group_3, SWT.NONE);
		button_1.addMouseListener(new MouseAdapter() {
			@Override
			public void mouseDown(MouseEvent e) {
				shell.close();
			}
		});
		button_1.setText("Annuler");
		button_1.setBounds(558, 10, 94, 28);
		m_bindingContext = initDataBindings();

	}
	protected DataBindingContext initDataBindings() {
		DataBindingContext bindingContext = new DataBindingContext();
		//
		ObservableListContentProvider listContentProvider = new ObservableListContentProvider();
		IObservableMap observeMap = BeansObservables.observeMap(listContentProvider.getKnownElements(), Etat.class, "libelle");
		comboViewer.setLabelProvider(new ObservableMapLabelProvider(observeMap));
		comboViewer.setContentProvider(listContentProvider);
		//
		IObservableList selfList = Properties.selfList(Etat.class).observe(listEtats);
		comboViewer.setInput(selfList);
		//
		return bindingContext;
	}
}
