package net.gui;

import java.math.BigDecimal;
import java.util.Iterator;

import hibernate.HibernateUtil;

import net.controller.AppController;
import net.models.Fraisforfait;
import net.view.Fraisforfaitaires_index;

import org.eclipse.swt.widgets.Display;
import org.eclipse.swt.widgets.MessageBox;
import org.eclipse.swt.widgets.Shell;
import org.eclipse.swt.widgets.Group;
import org.eclipse.swt.SWT;
import org.eclipse.swt.widgets.Label;
import org.eclipse.swt.widgets.Text;
import org.eclipse.swt.widgets.Button;
import org.eclipse.swt.events.KeyAdapter;
import org.eclipse.swt.events.KeyEvent;
import org.eclipse.swt.events.MouseAdapter;
import org.eclipse.swt.events.MouseEvent;
import org.eclipse.swt.events.SelectionAdapter;
import org.eclipse.swt.events.SelectionEvent;
import org.hibernate.Query;
import org.hibernate.Session;
import org.hibernate.Transaction;

public class Fraisforfaitaires_edit {

	protected Shell shlFraisForfaitaires;
	private Text textMontant;
	private Text textLibelle;
	private Text textId;
	private boolean editBool = false;

	/**
	 * Launch the application.
	 * 
	 * @param args
	 */
	public static void main(String[] args) {
		try {
			Fraisforfaitaires_edit window = new Fraisforfaitaires_edit();
			window.open();
		} catch (Exception e) {
			e.printStackTrace();
		}
	}

	/**
	 * Open the window.
	 */
	public void open() {
		Display display = Display.getDefault();
		createContents();
		shlFraisForfaitaires.open();
		shlFraisForfaitaires.layout();
		while (!shlFraisForfaitaires.isDisposed()) {
			if (!display.readAndDispatch()) {
				display.sleep();
			}
		}
		editBool=false;
	}
	
	/**
	 * Create contents of the window.
	 */
	protected void createContents() {
		shlFraisForfaitaires = new Shell(Display.getDefault(), SWT.BORDER | SWT.TITLE | SWT.APPLICATION_MODAL);
		shlFraisForfaitaires.setSize(192, 231);
		shlFraisForfaitaires.setText("Frais Forfaitaires");

		Group group = new Group(shlFraisForfaitaires, SWT.NONE);
		group.setText("Frais forfaitaires");
		group.setBounds(10, 10, 175, 133);

		Label label = new Label(group, SWT.NONE);
		label.setText("Id :");
		label.setBounds(10, 60, 55, 18);

		Label label_1 = new Label(group, SWT.NONE);
		label_1.setText("Libell\u00E9 :");
		label_1.setBounds(10, 84, 55, 15);

		Label label_2 = new Label(group, SWT.NONE);
		label_2.setText("Montant :");
		label_2.setBounds(10, 105, 55, 15);

		textMontant = new Text(group, SWT.BORDER);
		textMontant.setBounds(85, 102, 76, 21);

		textLibelle = new Text(group, SWT.BORDER);
		textLibelle.setBounds(85, 81, 76, 21);

		textId = new Text(group, SWT.BORDER);
		textId.setBounds(85, 57, 76, 21);

		Group group_1 = new Group(shlFraisForfaitaires, SWT.NONE);
		group_1.setBounds(10, 149, 175, 52);

		Button button = new Button(group_1, SWT.NONE);
		button.addMouseListener(new MouseAdapter() {
			@Override
			public void mouseDown(MouseEvent e) {
				MainWindow.fraisForfaitEdit=null;
				shlFraisForfaitaires.close();
			}
		});
		button.setText("Annuler");
		button.setBounds(90, 17, 75, 25);

		Button button_1 = new Button(group_1, SWT.NONE);
		button_1.addSelectionListener(new SelectionAdapter() {
			@Override
			public void widgetSelected(SelectionEvent e) {
				String id = textId.getText();

				// On vérifie directement qu'il n'y ait pas déjà une entrée pour
				// l'id
				Session session = HibernateUtil.getSession();

				Query query = session
						.createQuery("from Fraisforfait where id='" + id + "'");
				Iterator<Fraisforfait> it = query.list().iterator();
				session.close();
				Fraisforfait result = null;
				while (it.hasNext()) {
					result = (Fraisforfait) it.next();
				}

				if (result == null || editBool) {
					String libelle = textLibelle.getText();
					BigDecimal montant = new BigDecimal(textMontant.getText());
					Session session1 = HibernateUtil.getSession();
					Transaction tx = session1.beginTransaction();

					java.util.Date now = new java.util.Date();

					Fraisforfait ff = new Fraisforfait(id, libelle, montant);
					if(editBool){
						session1.delete(MainWindow.fraisForfaitEdit);
						Fraisforfaitaires_index.selfList.remove(MainWindow.fraisForfaitEdit);
					}
					session1.save(ff);
					tx.commit();
					session1.close();

					AppController.initListFraisForfait();
					Fraisforfaitaires_index.selfList.add(ff);
					MainWindow.fraisForfaitEdit=null;
					shlFraisForfaitaires.close();
				} else {
					MessageBox mb = new MessageBox(shlFraisForfaitaires);
					mb.setMessage("Un frais forfaitaire possède déjà cet id");
					mb.open();
				}
			}
		});
		button_1.setText("Valider");
		button_1.setBounds(2, 17, 75, 25);
		
		if(MainWindow.fraisForfaitEdit != null){
			textId.setText(MainWindow.fraisForfaitEdit.getId());
			textLibelle.setText(MainWindow.fraisForfaitEdit.getLibelle());
			textMontant.setText(String.valueOf(MainWindow.fraisForfaitEdit.getMontant()));
			editBool = true;
		}

	}

}
