package net.gui;

import java.io.UnsupportedEncodingException;
import java.security.MessageDigest;
import java.security.NoSuchAlgorithmException;

import net.controller.AppController;
import net.controller.LoginController;
import net.controller.MySHA1;

import org.eclipse.swt.widgets.Display;
import org.eclipse.swt.widgets.Shell;
import org.eclipse.swt.widgets.Group;
import org.eclipse.swt.SWT;
import org.eclipse.swt.widgets.Label;
import org.eclipse.swt.widgets.MessageBox;
import org.eclipse.swt.widgets.Text;
import org.eclipse.swt.widgets.Button;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.wb.swt.SWTResourceManager;
import org.eclipse.swt.events.SelectionAdapter;
import org.eclipse.swt.events.SelectionEvent;

public class LoginWindow {

	protected Shell shlLogin;
	private Text text;
	private Text text_1;

	/**
	 * Launch the application.
	 * @param args
	 */
	public static void main(String[] args) {
		try {
			LoginWindow window = new LoginWindow();
			window.open();
		} catch (Exception e) {
			e.printStackTrace();
		}
	}

	/**
	 * Open the window.
	 */
	public void open() {
		Display display = Display.getDefault();
		createContents();
		shlLogin.open();
		shlLogin.layout();
		while (!shlLogin.isDisposed()) {
			if (!display.readAndDispatch()) {
				display.sleep();
			}
		}
	}

	/**
	 * Create contents of the window.
	 */
	protected void createContents() {
		shlLogin = new Shell(Display.getDefault(), SWT.APPLICATION_MODAL | SWT.CLOSE);
		shlLogin.setSize(249, 325);
		shlLogin.setText("Login");
		
		Group group = new Group(shlLogin, SWT.NONE);
		group.setBounds(10, 10, 229, 147);
		
		Label lblConnectionEnTant = new Label(group, SWT.NONE);
		lblConnectionEnTant.setBounds(60, 10, 125, 50);
		lblConnectionEnTant.setText("Connection en tant \nqu'administrateur");
		
		Composite composite = new Composite(group, SWT.NONE);
		composite.setBackgroundImage(SWTResourceManager.getImage(LoginWindow.class, "/img/login.jpg"));
		composite.setBounds(82, 51, 64, 64);
		
		Group group_1 = new Group(shlLogin, SWT.NONE);
		group_1.setBounds(10, 163, 223, 58);
		
		Label lblLogin = new Label(group_1, SWT.NONE);
		lblLogin.setBounds(10, 10, 59, 14);
		lblLogin.setText("Login");
		
		Label lblPassword = new Label(group_1, SWT.NONE);
		lblPassword.setBounds(10, 36, 59, 14);
		lblPassword.setText("Password");
		
		text = new Text(group_1, SWT.BORDER);
		text.setBounds(75, 10, 134, 19);
		
		text_1 = new Text(group_1, SWT.BORDER | SWT.PASSWORD);
		text_1.setBounds(75, 33, 134, 19);
		
		Group group_2 = new Group(shlLogin, SWT.NONE);
		group_2.setBounds(10, 227, 223, 66);
		
		Button btnNewButton = new Button(group_2, SWT.NONE);
		btnNewButton.addSelectionListener(new SelectionAdapter() {
			@Override
			public void widgetSelected(SelectionEvent e) {
				String login = text.getText();
				String password = text_1.getText();
				password = LoginController.getHashedPassword(password);
				if(LoginController.verify(login, password)){
					shlLogin.close();
					MainWindow mw = new MainWindow();
					mw.open();
				}else{
					MessageBox mb = new MessageBox(shlLogin);
					mb.setText("Warning");
					mb.setMessage("Vous ne pouvez accéder à cette application.");
					mb.open();
				}
			}
		});
		
		btnNewButton.setBounds(10, 10, 199, 42);
		btnNewButton.setText("Connexion");
	}
}