package net.gui;

import java.util.List;

import net.controller.AppController;
import net.models.Familles;
import net.models.Fraisforfait;
import net.models.Medicaments;
import net.view.Accueil_index;
import net.view.FicheFrais_index;
import net.view.Fraisforfaitaires_index;
import net.view.Medicaments_index;
import net.view.Praticiens_index;
import net.view.RapportsVisites_index;
import net.view.Visiteurs_index;

import org.eclipse.core.databinding.observable.Realm;
import org.eclipse.jface.databinding.swt.SWTObservables;
import org.eclipse.swt.widgets.Display;
import org.eclipse.swt.widgets.Shell;
import org.eclipse.swt.widgets.Group;
import org.eclipse.swt.SWT;
import org.eclipse.swt.widgets.Label;
import org.eclipse.swt.widgets.Button;
import org.eclipse.swt.events.SelectionAdapter;
import org.eclipse.swt.events.SelectionEvent;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.layout.FillLayout;
import org.eclipse.swt.layout.FormLayout;
import org.eclipse.swt.layout.FormData;
import org.eclipse.swt.layout.FormAttachment;
import org.eclipse.swt.custom.StackLayout;
import org.eclipse.swt.layout.RowLayout;
import org.eclipse.swt.widgets.TabFolder;
import org.eclipse.swt.widgets.TabItem;

public class MainWindow {

	protected Shell shlGsb;
	protected Composite activeGroup;
	protected Group group_1;
	
	public static Fraisforfait fraisForfaitEdit = null;
	
	
	
	public void setActiveGroup(Composite composite){
		if(activeGroup == null || !composite.equals(activeGroup)){
			if(activeGroup != null){
				activeGroup.dispose();
			}
			this.activeGroup = composite;
			activeGroup.setBounds(0,0,group_1.getBounds().width,group_1.getBounds().height);
		}
	}

	/**
	 * Launch the application.
	 * @param args
	 */
	public static void main(String[] args) {
		try {
			MainWindow window = new MainWindow();
			window.open();
		} catch (Exception e) {
			e.printStackTrace();
		}
	}

	/**
	 * Open the window.
	 */
	public void open() {
		Realm.runWithDefault(SWTObservables.getRealm(Display.getDefault()),
				new Runnable() {
					public void run() {
				AppController.initListMedicaments();
				AppController.initListFamilles();
				AppController.initListFicheFrais();
				AppController.initListPraticiens();
				AppController.initListFraisForfait();
				AppController.initListEtats();
				AppController.initListUsers();
				AppController.initListTypesPraticiens();
				AppController.initListGroups();
				AppController.initListRapportsVisites();
				AppController.initListLabos();
				
				Display display = Display.getDefault();
				createContents();
				shlGsb.open();
				shlGsb.layout();
				while (!shlGsb.isDisposed()) {
					if (!display.readAndDispatch()) {
						display.sleep();
					}
				}
			}
		});
	}

	/**
	 * Create contents of the window.
	 */
	protected void createContents() {
		shlGsb = new Shell();
		shlGsb.setText("GSB");
		shlGsb.setSize(752, 445);
		shlGsb.setLayout(new FormLayout());
		
		Group grpInformations = new Group(shlGsb, SWT.NONE);
		grpInformations.setText("Informations");
		FormData fd_grpInformations = new FormData();
		fd_grpInformations.bottom = new FormAttachment(0, 126);
		fd_grpInformations.top = new FormAttachment(0, 61);
		fd_grpInformations.left = new FormAttachment(0, 10);
		grpInformations.setLayoutData(fd_grpInformations);
		
		final Label lblInfos = new Label(grpInformations, SWT.NONE);
		lblInfos.setBounds(10, 14, 656, 41);
		lblInfos.setText("Bienvenue dans l'application d'administration des fiches de frais et des comptes rendus des visisteurs m\u00E9dicaux de la\nsoci\u00E9t\u00E9 GSB.");
		
		group_1 = new Group(shlGsb, SWT.NONE);
		fd_grpInformations.right = new FormAttachment(group_1, 0, SWT.RIGHT);
		group_1.setLayout(new FillLayout(SWT.HORIZONTAL));
		FormData fd_group_1 = new FormData();
		fd_group_1.bottom = new FormAttachment(0, 398);
		fd_group_1.right = new FormAttachment(0, 724);
		fd_group_1.top = new FormAttachment(0, 132);
		fd_group_1.left = new FormAttachment(0, 10);
		group_1.setLayoutData(fd_group_1);
		
		final TabFolder tabFolder = new TabFolder(shlGsb, SWT.NONE);
		tabFolder.addSelectionListener(new SelectionAdapter() {
			@Override
			public void widgetSelected(SelectionEvent e) {
				switch (tabFolder.getSelectionIndex()) {
				case 0:
					Accueil_index ai = new Accueil_index(group_1, SWT.NONE);
					lblInfos.setText("Bienvenue "+AppController.getActiveUser().getPrenom()+" "+AppController.getActiveUser().getNom()+". Vous êtes sur l'application de gestion administrative des laboratoires GSB.");
					setActiveGroup(ai);
					break;
				case 1:
					FicheFrais_index ffi = new FicheFrais_index(group_1, SWT.NONE);
					lblInfos.setText("Vous pouvez ici visualiser la liste des fiches de frais enregistrées, les modifier, les supprimer ou en ajouter.");
					setActiveGroup(ffi);
					break;
				case 2:
					RapportsVisites_index rvi = new RapportsVisites_index(group_1, SWT.NONE);
					lblInfos.setText("Vous pouvez ici visualiser la liste des comptes rendus enregistrés, les modifier, les supprimer ou en ajouter.");
					setActiveGroup(rvi);
					break;
				case 3:
					Medicaments_index mi = new Medicaments_index(group_1, SWT.NONE);
					lblInfos.setText("Vous pouvez ici visualiser la liste des médicaments présents dans la base, les modifier, les supprimer ou en ajouter.");
					setActiveGroup(mi);
					break;
				case 4:
					Praticiens_index pi = new Praticiens_index(group_1, SWT.NONE);
					lblInfos.setText("Vous pouvez ici visualiser la liste des praticiens enregistrés dans la base de données, les modifier, les supprimer ou en ajouter.");
					setActiveGroup(pi);
					break;
				case 5:
					Visiteurs_index vi = new Visiteurs_index(group_1, SWT.NONE);
					lblInfos.setText("Vous pouvez ici visualiser la liste des visiteurs médicaux des laboratoires GSB, les modifier, les supprimer ou en ajouter.");
					setActiveGroup(vi);
					break;
				case 6:
					Fraisforfaitaires_index fffi = new Fraisforfaitaires_index(group_1, SWT.NONE);
					lblInfos.setText("Vous pouvez ici visualiser la liste des frais forfaitaires pris en charges pour les déplacement des visiteurs médicaux \ndes laboratoires gsb, vous pouvez aussi les modifier, les supprimer ou en ajouter.");
					setActiveGroup(fffi);
					break;
				}
			}
		});
		FormData fd_tabFolder = new FormData();
		fd_tabFolder.right = new FormAttachment(100, -10);
		fd_tabFolder.left = new FormAttachment(0, 10);
		fd_tabFolder.top = new FormAttachment(0, 10);
		fd_tabFolder.bottom = new FormAttachment(0, 55);
		tabFolder.setLayoutData(fd_tabFolder);
		
		TabItem tbtmAccueil = new TabItem(tabFolder, SWT.NONE);
		tbtmAccueil.setText("Accueil");
		
		TabItem tbtmNewItem = new TabItem(tabFolder, SWT.NONE);
		tbtmNewItem.setText("Fiche de Frais");
		
		TabItem tbtmNewItem_1 = new TabItem(tabFolder, SWT.NONE);
		tbtmNewItem_1.setText("Compte Rendus");
		
		TabItem tbtmMdicaments = new TabItem(tabFolder, SWT.NONE);
		tbtmMdicaments.setText("M\u00E9dicaments");
		
		TabItem tbtmPraticiens = new TabItem(tabFolder, SWT.NONE);
		tbtmPraticiens.setText("Praticiens");
		
		TabItem tbtmVisiteurs = new TabItem(tabFolder, SWT.NONE);
		tbtmVisiteurs.setText("Visiteurs");
		
		TabItem tbtmFraisForfaitaires = new TabItem(tabFolder, SWT.NONE);
		tbtmFraisForfaitaires.setText("Frais forfaitaires");

	}
}
