package net.gui;

import hibernate.HibernateUtil;

import java.sql.Date;
import java.util.ArrayList;
import java.util.Iterator;
import java.util.List;

import net.controller.AppController;
import net.models.Familles;
import net.models.Medicaments;
import net.view.Medicaments_index;

import org.eclipse.swt.widgets.Display;
import org.eclipse.swt.widgets.MessageBox;
import org.eclipse.swt.widgets.Shell;
import org.eclipse.swt.widgets.Group;
import org.eclipse.swt.SWT;
import org.eclipse.swt.widgets.Label;
import org.eclipse.swt.widgets.Text;
import org.eclipse.swt.widgets.Button;
import org.eclipse.swt.events.MouseAdapter;
import org.eclipse.swt.events.MouseEvent;
import org.eclipse.swt.widgets.Combo;
import org.eclipse.ui.internal.handlers.ReuseEditorTester;
import org.eclipse.core.databinding.observable.Realm;
import org.eclipse.jface.databinding.swt.SWTObservables;
import org.eclipse.jface.viewers.ComboViewer;
import org.eclipse.jface.viewers.IStructuredSelection;
import org.eclipse.jface.viewers.StructuredSelection;
import org.eclipse.core.databinding.DataBindingContext;
import org.eclipse.jface.databinding.viewers.ObservableListContentProvider;
import org.eclipse.core.databinding.observable.map.IObservableMap;
import org.eclipse.core.databinding.beans.BeansObservables;
import org.eclipse.jface.databinding.viewers.ObservableMapLabelProvider;
import org.eclipse.core.databinding.observable.list.IObservableList;
import org.eclipse.core.databinding.property.Properties;
import org.hibernate.Query;
import org.hibernate.Session;
import org.hibernate.Transaction;

public class Medicaments_edit {
	private DataBindingContext m_bindingContext;

	protected Shell shell;
	private Text text;
	private Text text_1;
	private Text text_2;
	private Text text_3;
	private Text text_4;
	private Text text_5;
	private List<Familles> listFamilles = new ArrayList<>();
	private ComboViewer comboViewer;

	/**
	 * Launch the application.
	 * @param args
	 */
	public static void main(String[] args) {
		Display display = Display.getDefault();
		Realm.runWithDefault(SWTObservables.getRealm(display), new Runnable() {
			public void run() {
				try {
					Medicaments_edit window = new Medicaments_edit();
					window.open();
				} catch (Exception e) {
					e.printStackTrace();
				}
			}
		});
	}

	/**
	 * Open the window.
	 */
	public void open() {
		Realm.runWithDefault(SWTObservables.getRealm(Display.getDefault()), new Runnable() {
			public void run() {
				
				listFamilles = AppController.getListFamilles();
				
				Display display = Display.getDefault();
				createContents();
				shell.open();
				shell.layout();
				while (!shell.isDisposed()) {
					if (!display.readAndDispatch()) {
						display.sleep();
					}
				}
			}
		});
	}

	/**
	 * Create contents of the window.
	 */
	protected void createContents() {
		shell = new Shell(Display.getDefault(), SWT.APPLICATION_MODAL|SWT.CLOSE);
		shell.setSize(485, 446);
		shell.setText("Mdicament");
		
		Group group = new Group(shell, SWT.NONE);
		group.setText("Medicaments");
		group.setBounds(10, 10, 459, 317);
		
		Label label = new Label(group, SWT.NONE);
		label.setText("Id :");
		label.setBounds(10, 24, 55, 15);
		
		Label label_1 = new Label(group, SWT.NONE);
		label_1.setText("Nom :");
		label_1.setBounds(10, 45, 55, 15);
		
		Label label_2 = new Label(group, SWT.NONE);
		label_2.setText("Famille :");
		label_2.setBounds(10, 66, 55, 15);
		
		Label label_3 = new Label(group, SWT.NONE);
		label_3.setText("Composition :");
		label_3.setBounds(10, 99, 87, 15);
		
		Label label_4 = new Label(group, SWT.NONE);
		label_4.setText("Effets :");
		label_4.setBounds(10, 167, 55, 15);
		
		Label label_5 = new Label(group, SWT.NONE);
		label_5.setText("Contre indications :");
		label_5.setBounds(10, 237, 130, 15);
		
		Label label_6 = new Label(group, SWT.NONE);
		label_6.setText("Prix :");
		label_6.setBounds(10, 292, 55, 15);
		
		comboViewer = new ComboViewer(group, SWT.READ_ONLY);
		Combo combo = comboViewer.getCombo();
		combo.setBounds(134, 63, 91, 23);
		
		text = new Text(group, SWT.BORDER);
		text.setBounds(149, 18, 76, 21);
		
		text_1 = new Text(group, SWT.BORDER);
		text_1.setBounds(149, 39, 76, 21);
		
		text_2 = new Text(group, SWT.BORDER);
		text_2.setBounds(149, 99, 300, 48);
		
		text_3 = new Text(group, SWT.BORDER);
		text_3.setBounds(149, 164, 300, 48);
		
		text_4 = new Text(group, SWT.BORDER);
		text_4.setBounds(149, 231, 300, 48);
		
		text_5 = new Text(group, SWT.BORDER);
		text_5.setBounds(149, 286, 76, 21);
		
		Group group_1 = new Group(shell, SWT.NONE);
		group_1.setBounds(10, 333, 459, 75);
		
		Button button = new Button(group_1, SWT.NONE);
		button.addMouseListener(new MouseAdapter() {
			@Override
			public void mouseDown(MouseEvent e) {
				String id = text.getText();

				// On vrifie directement qu'il n'y ait pas dj une entre pour
				// l'id
				Session session = HibernateUtil.getSession();

				Query query = session.createQuery("from Medicaments where id='"
						+ id + "'");
				Iterator<Medicaments> it = query.list().iterator();
				session.close();
				Medicaments result = null;
				while (it.hasNext()) {
					result = (Medicaments) it.next();
				}

				if (result == null) {
					String nom = text_1.getText();

					IStructuredSelection sel = ((IStructuredSelection) comboViewer
							.getSelection());
					Familles fam = (Familles) sel.getFirstElement();

					String composition = text_2.getText();
					String effets = text_3.getText();
					String contreIndic = text_4.getText();
					float prix = Float.valueOf(text_5.getText());
					Session session1 = HibernateUtil.getSession();
					Transaction tx = session1.beginTransaction();

					java.util.Date now = new java.util.Date();

					Medicaments med = new Medicaments(id, fam, nom,
							composition, effets, contreIndic, prix, now, now);
					session1.save(med);
					tx.commit();
					session1.close();

					AppController.initListMedicaments();
					Medicaments_index.selfList.add(med);
					shell.close();
				} else {
					MessageBox mb = new MessageBox(shell);
					mb.setMessage("Un mdicament possde dj cet id");
					mb.open();
				}
			}
		});
		button.setText("Valider");
		button.setBounds(10, 26, 87, 39);
		
		Button button_1 = new Button(group_1, SWT.NONE);
		button_1.addMouseListener(new MouseAdapter() {
			@Override
			public void mouseDown(MouseEvent e) {
				shell.close();
			}
		});
		button_1.setText("Annuler");
		button_1.setBounds(358, 26, 91, 39);
		m_bindingContext = initDataBindings();

	}
	protected DataBindingContext initDataBindings() {
		DataBindingContext bindingContext = new DataBindingContext();
		//
		ObservableListContentProvider listContentProvider = new ObservableListContentProvider();
		IObservableMap observeMap = BeansObservables.observeMap(listContentProvider.getKnownElements(), Familles.class, "libelle");
		comboViewer.setLabelProvider(new ObservableMapLabelProvider(observeMap));
		comboViewer.setContentProvider(listContentProvider);
		//
		IObservableList selfList = Properties.selfList(Familles.class).observe(listFamilles);
		comboViewer.setInput(selfList);
		//
		
		if (!listFamilles.isEmpty()) {
			comboViewer.setSelection(new StructuredSelection(listFamilles.get(0)));
		}
		
		return bindingContext;
	}
}
