package net.gui;

import hibernate.HibernateUtil;

import java.util.ArrayList;
import java.util.List;

import net.controller.AppController;
import net.models.Praticiens;
import net.models.TypesPraticiens;
import net.view.Praticiens_index;

import org.eclipse.core.databinding.observable.Realm;
import org.eclipse.jface.databinding.swt.SWTObservables;
import org.eclipse.swt.widgets.Display;
import org.eclipse.swt.widgets.Shell;
import org.eclipse.swt.widgets.Group;
import org.eclipse.swt.SWT;
import org.eclipse.swt.widgets.MessageBox;
import org.eclipse.swt.widgets.Text;
import org.eclipse.swt.widgets.Label;
import org.eclipse.swt.widgets.Combo;
import org.eclipse.swt.widgets.Button;
import org.eclipse.jface.viewers.ComboViewer;
import org.eclipse.jface.viewers.IStructuredSelection;
import org.eclipse.jface.viewers.StructuredSelection;
import org.eclipse.core.databinding.DataBindingContext;
import org.eclipse.jface.databinding.viewers.ObservableListContentProvider;
import org.eclipse.core.databinding.observable.map.IObservableMap;
import org.eclipse.core.databinding.beans.BeansObservables;
import org.eclipse.jface.databinding.viewers.ObservableMapLabelProvider;
import org.eclipse.core.databinding.observable.list.IObservableList;
import org.eclipse.core.databinding.property.Properties;
import org.eclipse.swt.events.MouseAdapter;
import org.eclipse.swt.events.MouseEvent;
import org.eclipse.swt.events.SelectionAdapter;
import org.eclipse.swt.events.SelectionEvent;
import org.hibernate.Session;
import org.hibernate.Transaction;

public class Praticiens_edit {
	private DataBindingContext m_bindingContext;

	protected Shell shlPraticien;
	private Text textNom;
	private Text textPrenom;
	private Text textAdresse;
	private Text textCP;
	private Text textVille;
	private List<TypesPraticiens> listTypesPraticiens = new ArrayList<>();
	private ComboViewer comboViewerType;

	/**
	 * Launch the application.
	 * @param args
	 */
	public static void main(String[] args) {
		Display display = Display.getDefault();
		Realm.runWithDefault(SWTObservables.getRealm(display), new Runnable() {
			public void run() {
				try {
					Praticiens_edit window = new Praticiens_edit();
					window.open();
				} catch (Exception e) {
					e.printStackTrace();
				}
			}
		});
	}

	/**
	 * Open the window.
	 */
	public void open() {
		Realm.runWithDefault(SWTObservables.getRealm(Display.getDefault()), new Runnable() {
			public void run() {
				
				listTypesPraticiens = AppController.getListTypesPraticiens();
				
				Display display = Display.getDefault();
				createContents();
				shlPraticien.open();
				shlPraticien.layout();
				while (!shlPraticien.isDisposed()) {
					if (!display.readAndDispatch()) {
						display.sleep();
					}
				}
			}
		});
	}

	/**
	 * Create contents of the window.
	 */
	protected void createContents() {
		shlPraticien = new Shell(Display.getDefault(), SWT.APPLICATION_MODAL | SWT.CLOSE);
		shlPraticien.setSize(276, 262);
		shlPraticien.setText("Praticien");
		
		Group group = new Group(shlPraticien, SWT.NONE);
		group.setText("Praticiens");
		group.setBounds(10, 10, 244, 156);
		
		textNom = new Text(group, SWT.BORDER);
		textNom.setBounds(118, 28, 116, 21);
		
		textPrenom = new Text(group, SWT.BORDER);
		textPrenom.setBounds(118, 49, 116, 21);
		
		textAdresse = new Text(group, SWT.BORDER);
		textAdresse.setBounds(118, 71, 116, 21);
		
		textCP = new Text(group, SWT.BORDER);
		textCP.setBounds(118, 88, 116, 21);
		
		textVille = new Text(group, SWT.BORDER);
		textVille.setBounds(118, 109, 116, 21);
		
		Label label = new Label(group, SWT.NONE);
		label.setText("Nom : ");
		label.setBounds(10, 31, 55, 15);
		
		Label label_1 = new Label(group, SWT.NONE);
		label_1.setText("Pr\u00E9nom : ");
		label_1.setBounds(10, 52, 55, 15);
		
		Label label_2 = new Label(group, SWT.NONE);
		label_2.setText("Adresse : ");
		label_2.setBounds(10, 74, 55, 15);
		
		Label label_3 = new Label(group, SWT.NONE);
		label_3.setText("CP : ");
		label_3.setBounds(10, 91, 55, 15);
		
		Label label_4 = new Label(group, SWT.NONE);
		label_4.setText("Ville : ");
		label_4.setBounds(10, 112, 55, 15);
		
		Label label_5 = new Label(group, SWT.NONE);
		label_5.setText("Type : ");
		label_5.setBounds(10, 131, 55, 15);
		
		comboViewerType = new ComboViewer(group, SWT.READ_ONLY);
		Combo combo = comboViewerType.getCombo();
		combo.setBounds(118, 128, 116, 23);
		
		Group group_1 = new Group(shlPraticien, SWT.NONE);
		group_1.setBounds(10, 172, 244, 44);
		
		Button button = new Button(group_1, SWT.NONE);
		button.addSelectionListener(new SelectionAdapter() {
			@Override
			public void widgetSelected(SelectionEvent e) {
					String nom = textNom.getText();
					String prenom = textPrenom.getText();
					String adresse = textAdresse.getText();
					String cp = textCP.getText();
					String ville = textVille.getText();
					
					IStructuredSelection sel = ((IStructuredSelection) comboViewerType.getSelection());
					TypesPraticiens typePra = (TypesPraticiens) sel.getFirstElement();
					
					Session session1 = HibernateUtil.getSession();
					Transaction tx = session1.beginTransaction();
					
					java.util.Date now = new java.util.Date();
					
					Praticiens pra = new Praticiens(typePra, nom, prenom, adresse, cp, ville, null, false, now, now);
					session1.save(pra);				
					tx.commit();
					session1.close();
					
					AppController.initListPraticiens();
					Praticiens_index.selfList.add(pra);
					shlPraticien.close();
			}
		});
		button.setText("Valider");
		button.setBounds(10, 10, 75, 25);
		
		Button button_1 = new Button(group_1, SWT.NONE);
		button_1.addMouseListener(new MouseAdapter() {
			@Override
			public void mouseDown(MouseEvent e) {
				shlPraticien.close();
			}
		});
		button_1.setText("Annuler");
		button_1.setBounds(155, 10, 75, 25);
		m_bindingContext = initDataBindings();

	}
	protected DataBindingContext initDataBindings() {
		DataBindingContext bindingContext = new DataBindingContext();
		//
		ObservableListContentProvider listContentProvider = new ObservableListContentProvider();
		IObservableMap observeMap = BeansObservables.observeMap(listContentProvider.getKnownElements(), TypesPraticiens.class, "id");
		comboViewerType.setLabelProvider(new ObservableMapLabelProvider(observeMap));
		comboViewerType.setContentProvider(listContentProvider);
		//
		IObservableList selfList = Properties.selfList(TypesPraticiens.class).observe(listTypesPraticiens);
		comboViewerType.setInput(selfList);
		//
		
		if (!listTypesPraticiens.isEmpty()) {
			comboViewerType.setSelection(new StructuredSelection(listTypesPraticiens.get(0)));
		}
		
		return bindingContext;
	}
}
