package net.gui;

import hibernate.HibernateUtil;

import java.text.ParseException;
import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.Date;
import java.util.Iterator;
import java.util.List;

import net.controller.AppController;
import net.controller.LoginController;
import net.models.Groups;
import net.models.Labos;
import net.models.Users;
import net.view.Visiteurs_index;

import org.eclipse.swt.widgets.Display;
import org.eclipse.swt.widgets.Shell;
import org.eclipse.swt.widgets.Group;
import org.eclipse.swt.SWT;
import org.eclipse.swt.widgets.Label;
import org.eclipse.wb.swt.SWTResourceManager;
import org.eclipse.swt.layout.FillLayout;
import org.eclipse.swt.layout.FormLayout;
import org.eclipse.swt.layout.FormData;
import org.eclipse.swt.layout.FormAttachment;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.MessageBox;
import org.eclipse.swt.widgets.Text;
import org.eclipse.swt.widgets.DateTime;
import org.eclipse.swt.widgets.Combo;
import org.eclipse.swt.widgets.Button;
import org.eclipse.core.databinding.observable.Realm;
import org.eclipse.jface.databinding.swt.SWTObservables;
import org.eclipse.jface.viewers.ComboViewer;
import org.eclipse.jface.viewers.IStructuredSelection;
import org.eclipse.jface.viewers.StructuredSelection;
import org.eclipse.core.databinding.DataBindingContext;
import org.eclipse.jface.databinding.viewers.ObservableListContentProvider;
import org.eclipse.core.databinding.observable.map.IObservableMap;
import org.eclipse.core.databinding.beans.BeansObservables;
import org.eclipse.jface.databinding.viewers.ObservableMapLabelProvider;
import org.eclipse.core.databinding.observable.list.IObservableList;
import org.eclipse.core.databinding.property.Properties;
import org.eclipse.swt.events.MouseAdapter;
import org.eclipse.swt.events.MouseEvent;
import org.eclipse.swt.events.SelectionAdapter;
import org.eclipse.swt.events.SelectionEvent;
import org.hibernate.Query;
import org.hibernate.Session;
import org.hibernate.Transaction;

public class Visiteurs_edit {
	private DataBindingContext m_bindingContext;

	protected Shell shlPopup;
	private Text textMatricule;
	private Text textNom;
	private Text textPrenom;
	private Text textAdresse;
	private Text textCodePostal;
	private Text textVille;
	private Text textLogin;
	private Text textPwd;
	private Text textPwdConfirm;

	private List<Labos> listLabos = new ArrayList<>();
	private List<Groups> listGroups = new ArrayList<>();
	private ComboViewer comboViewer;
	private ComboViewer comboViewer_1;
	/**
	 * Launch the application.
	 * @param args
	 */
	public static void main(String[] args) {
		Display display = Display.getDefault();
		Realm.runWithDefault(SWTObservables.getRealm(display), new Runnable() {
			public void run() {
				try {
					Visiteurs_edit window = new Visiteurs_edit();
					window.open();
				} catch (Exception e) {
					e.printStackTrace();
				}
			}
		});
	}

	/**
	 * Open the window.
	 */
	public void open() {
		Realm.runWithDefault(SWTObservables.getRealm(Display.getDefault()), new Runnable() {
			public void run() {
				
				listLabos = AppController.getListLabos();
				listGroups = AppController.getListGroups();
				
				Display display = Display.getDefault();
				createContents();
				shlPopup.open();
				shlPopup.layout();
				while (!shlPopup.isDisposed()) {
					if (!display.readAndDispatch()) {
						display.sleep();
					}
				}
			}
		});
	}

	/**
	 * Create contents of the window.
	 */
	protected void createContents() {
		shlPopup = new Shell(Display.getDefault(), SWT.APPLICATION_MODAL | SWT.CLOSE);
		shlPopup.setSize(471, 389);
		shlPopup.setText("Visiteur");
		shlPopup.setLayout(null);
		
		Group group = new Group(shlPopup, SWT.NONE);
		group.setBounds(10, 10, 430, 81);
		group.setLayout(new FormLayout());
		
		Label label = new Label(group, SWT.NONE);
		label.setText("Ajouter un Utilisateur :");
		label.setForeground(SWTResourceManager.getColor(SWT.COLOR_LIST_SELECTION_TEXT));
		label.setFont(SWTResourceManager.getFont("Lucida Grande", 12, SWT.BOLD | SWT.ITALIC));
		FormData fd_label = new FormData();
		fd_label.top = new FormAttachment(0, 5);
		label.setLayoutData(fd_label);
		
		Label label_1 = new Label(group, SWT.NONE);
		fd_label.left = new FormAttachment(label_1, 0, SWT.LEFT);
		label_1.setText("Entrez les informations n\u00E9cessaire \u00E0 l'ajout d'un \nutilisateur.");
		FormData fd_label_1 = new FormData();
		fd_label_1.bottom = new FormAttachment(0, 52);
		fd_label_1.top = new FormAttachment(0, 25);
		fd_label_1.left = new FormAttachment(0, 5);
		label_1.setLayoutData(fd_label_1);
		
		Composite composite = new Composite(group, SWT.NONE);
		composite.setBackgroundImage(SWTResourceManager.getImage(Visiteurs_edit.class, "/img/comptes_utilisateurs.png"));
		composite.setLayout(new FillLayout(SWT.HORIZONTAL));
		FormData fd_composite = new FormData();
		fd_composite.top = new FormAttachment(0);
		fd_composite.right = new FormAttachment(100, -10);
		fd_composite.bottom = new FormAttachment(100, -7);
		fd_composite.left = new FormAttachment(100, -69);
		composite.setLayoutData(fd_composite);
		
		Group group_1 = new Group(shlPopup, SWT.NONE);
		group_1.setBounds(10, 97, 430, 181);
		
		Label label_2 = new Label(group_1, SWT.NONE);
		label_2.setText("Matricule");
		label_2.setBounds(10, 24, 59, 14);
		
		Label label_3 = new Label(group_1, SWT.NONE);
		label_3.setText("Nom");
		label_3.setBounds(10, 44, 59, 14);
		
		Label label_4 = new Label(group_1, SWT.NONE);
		label_4.setText("Pr\u00E9nom");
		label_4.setBounds(10, 64, 59, 14);
		
		Label label_5 = new Label(group_1, SWT.NONE);
		label_5.setText("Adresse");
		label_5.setBounds(10, 84, 59, 14);
		
		Label label_6 = new Label(group_1, SWT.NONE);
		label_6.setText("Code Postal");
		label_6.setBounds(10, 104, 72, 14);
		
		Label label_7 = new Label(group_1, SWT.NONE);
		label_7.setText("Ville");
		label_7.setBounds(10, 124, 59, 14);
		
		Label label_8 = new Label(group_1, SWT.NONE);
		label_8.setText("Date d'embauche");
		label_8.setBounds(10, 157, 97, 14);
		
		Label label_10 = new Label(group_1, SWT.NONE);
		label_10.setText("Laboratoire");
		label_10.setBounds(219, 44, 72, 14);
		
		Label label_11 = new Label(group_1, SWT.NONE);
		label_11.setText("Login");
		label_11.setBounds(219, 84, 59, 14);
		
		Label label_12 = new Label(group_1, SWT.NONE);
		label_12.setText("Mot de passe");
		label_12.setBounds(219, 104, 82, 14);
		
		Label label_13 = new Label(group_1, SWT.NONE);
		label_13.setText("Confirmer");
		label_13.setBounds(219, 124, 82, 14);
		
		textMatricule = new Text(group_1, SWT.BORDER);
		textMatricule.setBounds(115, 19, 64, 19);
		
		textNom = new Text(group_1, SWT.BORDER);
		textNom.setBounds(115, 39, 64, 19);
		
		textPrenom = new Text(group_1, SWT.BORDER);
		textPrenom.setBounds(115, 59, 64, 19);
		
		textAdresse = new Text(group_1, SWT.BORDER);
		textAdresse.setBounds(115, 79, 64, 19);
		
		textCodePostal = new Text(group_1, SWT.BORDER);
		textCodePostal.setBounds(115, 99, 64, 19);
		
		textVille = new Text(group_1, SWT.BORDER);
		textVille.setBounds(115, 121, 64, 19);
		
		final DateTime dateTime = new DateTime(group_1, SWT.BORDER);
		dateTime.setBounds(113, 144, 92, 27);
		
		textLogin = new Text(group_1, SWT.BORDER);
		textLogin.setBounds(329, 81, 91, 19);
		
		textPwd = new Text(group_1, SWT.BORDER | SWT.PASSWORD);
		textPwd.setBounds(329, 101, 91, 19);
		
		textPwdConfirm = new Text(group_1, SWT.BORDER | SWT.PASSWORD);
		textPwdConfirm.setBounds(329, 121, 91, 19);
		
		Label label_14 = new Label(group_1, SWT.NONE);
		label_14.setText("Groupe");
		label_14.setBounds(219, 157, 59, 14);
		
		comboViewer = new ComboViewer(group_1, SWT.READ_ONLY);
		final Combo comboLabo = comboViewer.getCombo();
		comboLabo.setBounds(329, 35, 91, 23);
		
		comboViewer_1 = new ComboViewer(group_1, SWT.READ_ONLY);
		Combo comboGroup = comboViewer_1.getCombo();
		comboGroup.setBounds(329, 148, 91, 23);
		
		Group group_2 = new Group(shlPopup, SWT.NONE);
		group_2.setBounds(10, 284, 430, 57);
		
		Button button = new Button(group_2, SWT.NONE);
		button.addSelectionListener(new SelectionAdapter() {
			@Override
			public void widgetSelected(SelectionEvent e) {
				String matricule = textMatricule.getText();
				//On vrifie directement qu'il n'y ait pas dj une entre pour l'id
				Session session = HibernateUtil.getSession();
				
				Query query = session.createQuery("from Users where id='"+matricule+"'");
				Iterator<Users> it = query.list().iterator();
				session.close();
				Users result = null;
				while (it.hasNext()) {
					result = (Users) it.next();
				}
				
				if(result == null){
					if(textPwd.getText().equals(textPwdConfirm.getText())){
						String nom = textNom.getText();
						String prenom = textPrenom.getText();
						String adresse = textAdresse.getText();
						String cp = textCodePostal.getText();
						String ville = textVille.getText();
						
						Date dateEmbauche = new Date();
						
						//On rcupre le labo
						IStructuredSelection selLabo = ((IStructuredSelection) comboViewer.getSelection());
						Labos lab = (Labos) selLabo.getFirstElement();
						
						//On rcupre le groupe
						IStructuredSelection selGroup = ((IStructuredSelection) comboViewer_1.getSelection());
						Groups group = (Groups) selGroup.getFirstElement();
						
						String username = textLogin.getText();
						String password =  textPwd.getText();
						password = LoginController.getHashedPassword(password);
						Date created = new Date();
						Date modified = new Date();
						
						Session session1 = HibernateUtil.getSession();
						Transaction tx = session1.beginTransaction();
						Users user = new Users(matricule, group, lab, nom, prenom, adresse, cp, ville, dateEmbauche, username, password, created, modified);
						session1.save(user);
						tx.commit();
						session1.close();
						
						AppController.initListUsers();
						Visiteurs_index.selfList.add(user);
						shlPopup.close();
					} else {
						MessageBox mb = new MessageBox(shlPopup);
						mb.setMessage("La confirmation du mot de passe est errone");
						mb.open();
					}
				}
				else
				{
					MessageBox mb = new MessageBox(shlPopup);
					mb.setMessage("Un visiteur possde dj cet id");
					mb.open();
				}
			}
		});
		button.setText("Ajouter");
		button.setBounds(10, 10, 94, 33);
		
		Button btnNewButton = new Button(group_2, SWT.NONE);
		btnNewButton.addMouseListener(new MouseAdapter() {
			@Override
			public void mouseDown(MouseEvent e) {
				shlPopup.close();
			}
		});
		btnNewButton.setBounds(315, 10, 101, 33);
		btnNewButton.setText("Annuler");
		m_bindingContext = initDataBindings();

	}
	protected DataBindingContext initDataBindings() {
		DataBindingContext bindingContext = new DataBindingContext();
		//
		ObservableListContentProvider listContentProvider = new ObservableListContentProvider();
		IObservableMap observeMap = BeansObservables.observeMap(listContentProvider.getKnownElements(), Labos.class, "nom");
		comboViewer.setLabelProvider(new ObservableMapLabelProvider(observeMap));
		comboViewer.setContentProvider(listContentProvider);
		//
		IObservableList selfList = Properties.selfList(Labos.class).observe(listLabos);
		comboViewer.setInput(selfList);
		//
		ObservableListContentProvider listContentProvider_1 = new ObservableListContentProvider();
		IObservableMap observeMap_1 = BeansObservables.observeMap(listContentProvider_1.getKnownElements(), Groups.class, "name");
		comboViewer_1.setLabelProvider(new ObservableMapLabelProvider(observeMap_1));
		comboViewer_1.setContentProvider(listContentProvider_1);
		//
		IObservableList selfList_1 = Properties.selfList(Groups.class).observe(listGroups);
		comboViewer_1.setInput(selfList_1);
		//
		
		if (!listLabos.isEmpty()) {
			comboViewer.setSelection(new StructuredSelection(listLabos.get(0)));
		}
		
		if (!listGroups.isEmpty()) {
			comboViewer_1.setSelection(new StructuredSelection(listGroups.get(0)));
		}
		
		return bindingContext;
	}
}
