package net.view;

import hibernate.HibernateUtil;

import java.awt.Window;
import java.util.ArrayList;
import java.util.List;

import net.controller.AppController;
import net.gui.Fraisforfaitaires_edit;
import net.gui.MainWindow;
import net.models.Fraisforfait;

import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.Label;
import org.eclipse.swt.SWT;
import org.eclipse.swt.widgets.MessageBox;
import org.eclipse.swt.widgets.Table;
import org.eclipse.swt.widgets.Button;
import org.eclipse.swt.widgets.Group;
import org.eclipse.swt.events.SelectionAdapter;
import org.eclipse.swt.events.SelectionEvent;
import org.eclipse.jface.viewers.IStructuredSelection;
import org.eclipse.jface.viewers.TableViewer;
import org.eclipse.jface.viewers.TableViewerColumn;
import org.eclipse.core.databinding.DataBindingContext;
import org.eclipse.jface.databinding.viewers.ObservableListContentProvider;
import org.eclipse.core.databinding.observable.map.IObservableMap;
import org.eclipse.core.databinding.beans.BeansObservables;
import org.eclipse.jface.databinding.viewers.ObservableMapLabelProvider;
import org.eclipse.core.databinding.observable.list.IObservableList;
import org.eclipse.core.databinding.property.Properties;
import org.hibernate.Session;
import org.hibernate.Transaction;

public class Fraisforfaitaires_index extends Composite {
	private DataBindingContext m_bindingContext;
	private Table table;
	public static List<Fraisforfait> listFraisForfait = new ArrayList<>();
	private TableViewer tableViewer;
	public static IObservableList selfList;
	/**
	 * Create the composite.
	 * @param parent
	 * @param style
	 */
	public Fraisforfaitaires_index(Composite parent, int style) {
		super(parent, style);
		
		listFraisForfait = AppController.getListFraisForfait();
		
		Group grpFraisForfaitaires = new Group(this, SWT.NONE);
		grpFraisForfaitaires.setText("Frais forfaitaires");
		grpFraisForfaitaires.setBounds(10, 10, 660, 203);
		
		tableViewer = new TableViewer(grpFraisForfaitaires, SWT.BORDER | SWT.FULL_SELECTION);
		table = tableViewer.getTable();
		table.setBounds(10, 22, 640, 171);
		table.setHeaderVisible(true);
		
		TableViewerColumn columnLibelle = new TableViewerColumn(tableViewer, SWT.NONE);
		TableViewerColumn columnMontant = new TableViewerColumn(tableViewer, SWT.NONE);
		
		columnLibelle.getColumn().setText("Libelle");
		columnMontant.getColumn().setText("Montant");
		
		columnLibelle.getColumn().setWidth(328);
		columnMontant.getColumn().setWidth(305);
		
		Group group = new Group(this, SWT.NONE);
		group.setBounds(10, 219, 660, 40);
		
		Button btnAjouter = new Button(group, SWT.NONE);
		btnAjouter.addSelectionListener(new SelectionAdapter() {
			@Override
			public void widgetSelected(SelectionEvent e) {
				Fraisforfaitaires_edit ffe = new Fraisforfaitaires_edit();
				ffe.open();
				
			}
		});
		btnAjouter.setBounds(10, 10, 88, 26);
		btnAjouter.setText("Ajouter");
		
		Button btnDelete = new Button(group, SWT.NONE);
		btnDelete.setBounds(562, 10, 88, 26);
		btnDelete.addSelectionListener(new SelectionAdapter() {
			@Override
			public void widgetSelected(SelectionEvent e) {
				IStructuredSelection sel = (IStructuredSelection) tableViewer.getSelection();
				if(sel != null){
					Fraisforfait ff = (Fraisforfait) sel.getFirstElement();
					Session session = HibernateUtil.getSession();
					Transaction tx = session.beginTransaction();
					session.delete(ff);
					tx.commit();
					session.close();
					AppController.initListFraisForfait();
					getListInput().remove(ff);
				}
			}
		});
		btnDelete.setText("Delete");
		
		Button btnEditer = new Button(group, SWT.NONE);
		btnEditer.addSelectionListener(new SelectionAdapter() {
			@Override
			public void widgetSelected(SelectionEvent e) {
				IStructuredSelection sel = (IStructuredSelection) tableViewer.getSelection();
				if(sel != null){
					MainWindow.fraisForfaitEdit = (Fraisforfait) sel.getFirstElement();
					Fraisforfaitaires_edit ffe = new Fraisforfaitaires_edit();
					ffe.open();
				}
			}
		});
		btnEditer.setBounds(290, 11, 75, 25);
		btnEditer.setText("Editer");
		m_bindingContext = initDataBindings();

	}
	
	@Override
	protected void checkSubclass() {	
	
	}
	protected DataBindingContext initDataBindings() {
		DataBindingContext bindingContext = new DataBindingContext();
		//
		ObservableListContentProvider listContentProvider = new ObservableListContentProvider();
		IObservableMap[] observeMaps = BeansObservables.observeMaps(listContentProvider.getKnownElements(), Fraisforfait.class, new String[]{"libelle", "montant"});
		tableViewer.setLabelProvider(new ObservableMapLabelProvider(observeMaps));
		tableViewer.setContentProvider(listContentProvider);
		//
		selfList = Properties.selfList(Fraisforfait.class).observe(listFraisForfait);
		tableViewer.setInput(selfList);
		//
		return bindingContext;
	}
	
	public IObservableList getListInput(){
		return selfList;
	}
}
