package net.view;

import hibernate.HibernateUtil;

import java.util.ArrayList;
import java.util.List;

import net.controller.AppController;
import net.gui.Medicaments_edit;
import net.models.Medicaments;

import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.Label;
import org.eclipse.swt.SWT;
import org.eclipse.swt.widgets.Table;
import org.eclipse.swt.widgets.Combo;
import org.eclipse.swt.widgets.Button;
import org.eclipse.swt.widgets.Group;
import org.eclipse.swt.events.SelectionAdapter;
import org.eclipse.swt.events.SelectionEvent;
import org.eclipse.jface.viewers.ComboViewer;
import org.eclipse.jface.viewers.IStructuredSelection;
import org.eclipse.jface.viewers.TableViewerColumn;
import org.eclipse.core.databinding.DataBindingContext;
import org.eclipse.jface.databinding.viewers.ObservableListContentProvider;
import org.eclipse.core.databinding.observable.map.IObservableMap;
import org.eclipse.core.databinding.beans.BeansObservables;
import org.eclipse.jface.databinding.viewers.ObservableMapLabelProvider;
import org.eclipse.core.databinding.observable.list.IObservableList;
import org.eclipse.core.databinding.observable.list.WritableList;
import org.eclipse.core.databinding.property.Properties;
import org.hibernate.Query;
import org.hibernate.Session;
import org.hibernate.Transaction;

import net.models.Familles;
import org.eclipse.jface.viewers.TableViewer;

public class Medicaments_index extends Composite {
	private DataBindingContext m_bindingContext;
	public static List<Medicaments> listMedicaments = new ArrayList<>();
	public static List<Familles> listFamilles = new ArrayList<>();
	private ComboViewer comboViewer;
	private Table table;
	private TableViewer tableViewer;
	public static IObservableList selfList;

	/**
	 * Create the composite.
	 * @param parent
	 * @param style
	 */
	public Medicaments_index(Composite parent, int style) {
		super(parent, style);
		
		listMedicaments = AppController.getListMedicaments();
		listFamilles = AppController.getListFamilles();
		
		Group grpMedicamentsIndex = new Group(this, SWT.NONE);
		grpMedicamentsIndex.setText("Famille");
		grpMedicamentsIndex.setBounds(10, 10, 144, 54);
		
		Label lblNewLabel = new Label(grpMedicamentsIndex, SWT.NONE);
		lblNewLabel.setText("Famille :");
		
		comboViewer = new ComboViewer(grpMedicamentsIndex, SWT.READ_ONLY);
		Combo combo = comboViewer.getCombo();
		combo.addSelectionListener(new SelectionAdapter() {
			@Override
			public void widgetSelected(SelectionEvent e) {
				listMedicaments = new ArrayList<>();
				String nomFamille = comboViewer.getSelection().toString();
				for (Medicaments med : AppController.getListMedicaments()) {
					if(med.getFamilles().equals(nomFamille)){
						listMedicaments.add(med);
					}
				}
			}
		});
		combo.setBounds(10, 21, 124, 23);
		
		Group grpListeDesMdicaments = new Group(this, SWT.NONE);
		grpListeDesMdicaments.setText("Liste des M\u00E9dicaments");
		grpListeDesMdicaments.setBounds(160, 10, 506, 192);
		
		tableViewer = new TableViewer(grpListeDesMdicaments, SWT.BORDER | SWT.FULL_SELECTION);
		table = tableViewer.getTable();
		table.setBounds(10, 21, 486, 161);
		
		table.setHeaderVisible(true);
		
		TableViewerColumn columnId = new TableViewerColumn(tableViewer, SWT.NONE);
		TableViewerColumn columnNomMedoc = new TableViewerColumn(tableViewer, SWT.NONE);
		
		columnId.getColumn().setText("Identifiant");
		columnNomMedoc.getColumn().setText("Nom Commercial");
		
		columnId.getColumn().setWidth(248);
		columnNomMedoc.getColumn().setWidth(215);
		
		Group group = new Group(this, SWT.NONE);
		group.setBounds(10, 208, 656, 51);
		
		Button button = new Button(group, SWT.NONE);
		button.addSelectionListener(new SelectionAdapter() {
			@Override
			public void widgetSelected(SelectionEvent e) {
				Medicaments_edit me = new Medicaments_edit();
				me.open();
			}
		});
		button.setText("Ajouter");
		button.setBounds(10, 10, 85, 25);
		
		Button btnDelete = new Button(group, SWT.NONE);
		btnDelete.addSelectionListener(new SelectionAdapter() {
			@Override
			public void widgetSelected(SelectionEvent e) {
				IStructuredSelection sel = (IStructuredSelection) tableViewer.getSelection();
				if(sel != null){
					Medicaments med = (Medicaments) sel.getFirstElement();
					Session session = HibernateUtil.getSession();
					Transaction tx = session.beginTransaction();
					session.delete(med);
					tx.commit();
					session.close();
					//On rinitialise la liste de mdicaments
					AppController.initListMedicaments();
					//On supprime en direct
					getListInput().remove(med);
				}
			}
		});
		btnDelete.setBounds(561, 12, 85, 25);
		btnDelete.setText("Delete");
		m_bindingContext = initDataBindings();
	}

	@Override
	protected void checkSubclass() {
		// Disable the check that prevents subclassing of SWT components
	}
	protected DataBindingContext initDataBindings() {
		DataBindingContext bindingContext = new DataBindingContext();
		//
		ObservableListContentProvider listContentProvider = new ObservableListContentProvider();
		IObservableMap[] observeMap = BeansObservables.observeMaps(listContentProvider.getKnownElements(), Medicaments.class, new String[]{"id", "nomCommercial"});
		tableViewer.setLabelProvider(new ObservableMapLabelProvider(observeMap));
		tableViewer.setContentProvider(listContentProvider);
		//
		selfList = Properties.selfList(Medicaments.class).observe(listMedicaments);
		tableViewer.setInput(selfList);
		//
		ObservableListContentProvider listContentProvider_1 = new ObservableListContentProvider();
		IObservableMap observeMap_1 = BeansObservables.observeMap(listContentProvider_1.getKnownElements(), Familles.class, "libelle");
		comboViewer.setLabelProvider(new ObservableMapLabelProvider(observeMap_1));
		comboViewer.setContentProvider(listContentProvider_1);
		//
		IObservableList selfList_1 = Properties.selfList(Familles.class).observe(listFamilles);
		comboViewer.setInput(selfList_1);
		//
		return bindingContext;
	}
	public IObservableList getListInput(){
		return selfList;
	}
}
