package net.view;

import hibernate.HibernateUtil;

import java.util.ArrayList;
import java.util.List;

import javax.swing.table.TableColumn;

import net.controller.AppController;
import net.gui.Praticiens_edit;
import net.gui.Visiteurs_edit;
import net.models.Praticiens;
import net.models.TypesPraticiens;

import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.Label;
import org.eclipse.swt.SWT;
import org.eclipse.swt.widgets.Table;
import org.eclipse.swt.widgets.Combo;
import org.eclipse.swt.widgets.Group;
import org.eclipse.swt.widgets.Button;
import org.eclipse.wb.swt.SWTResourceManager;
import org.eclipse.swt.events.SelectionAdapter;
import org.eclipse.swt.events.SelectionEvent;
import org.eclipse.jface.viewers.IStructuredSelection;
import org.eclipse.jface.viewers.TableViewer;
import org.eclipse.jface.viewers.TableViewerColumn;
import org.eclipse.core.databinding.DataBindingContext;
import org.eclipse.jface.databinding.viewers.ObservableListContentProvider;
import org.eclipse.core.databinding.observable.map.IObservableMap;
import org.eclipse.core.databinding.beans.BeansObservables;
import org.eclipse.jface.databinding.viewers.ObservableMapLabelProvider;
import org.eclipse.core.databinding.observable.list.IObservableList;
import org.eclipse.core.databinding.property.Properties;
import org.eclipse.jface.viewers.ComboViewer;
import org.hibernate.Session;
import org.hibernate.Transaction;

public class Praticiens_index extends Composite {
	private DataBindingContext m_bindingContext;
	private Table table;
	private List<Praticiens> listPraticiens = new ArrayList<>();
	private List<TypesPraticiens> listTypesPraticiens = new ArrayList<>();
	private TableViewer tableViewer;
	private ComboViewer comboViewer;
	public static IObservableList selfList;

	/**
	 * Create the composite.
	 * @param parent
	 * @param style
	 */
	public Praticiens_index(Composite parent, int style) {
		super(parent, style);
		
		listPraticiens = AppController.getListPraticiens();
		listTypesPraticiens = AppController.getListTypesPraticiens();
		
		Group grpType = new Group(this, SWT.NONE);
		grpType.setText("Type :");
		grpType.setBounds(6, 10, 178, 54);
		
		comboViewer = new ComboViewer(grpType, SWT.READ_ONLY);
		Combo combo = comboViewer.getCombo();
		combo.setBounds(10, 21, 158, 23);
		
		Group grpListeDesPraticiens = new Group(this, SWT.NONE);
		grpListeDesPraticiens.setText("Praticiens");
		grpListeDesPraticiens.setBounds(193, 10, 462, 194);
		
		tableViewer = new TableViewer(grpListeDesPraticiens, SWT.BORDER | SWT.FULL_SELECTION);
		table = tableViewer.getTable();
		table.setBounds(10, 23, 442, 161);
		table.setHeaderVisible(true);
		
		TableViewerColumn columnNom = new TableViewerColumn(tableViewer, SWT.NONE);
		TableViewerColumn columnPrenom = new TableViewerColumn(tableViewer, SWT.NONE);
		TableViewerColumn columnVille = new TableViewerColumn(tableViewer, SWT.NONE);
		
		columnNom.getColumn().setText("Nom");
		columnPrenom.getColumn().setText("Prenom");
		columnVille.getColumn().setText("Ville");
		
		columnNom.getColumn().setWidth(173);
		columnPrenom.getColumn().setWidth(138);
		columnVille.getColumn().setWidth(110);
		
		Composite composite = new Composite(this, SWT.BORDER);
		composite.setBackground(SWTResourceManager.getColor(SWT.COLOR_WHITE));
		composite.setBounds(6, 492, 387, 49);
		
		Button button = new Button(composite, SWT.NONE);
		button.setText("Ajouter");
		button.setBounds(194, 10, 179, 25);
		
		Group group = new Group(this, SWT.NONE);
		group.setBounds(6, 210, 649, 50);
		
		Button btnAjouter = new Button(group, SWT.NONE);
		btnAjouter.addSelectionListener(new SelectionAdapter() {
			@Override
			public void widgetSelected(SelectionEvent e) {
				Praticiens_edit pe = new Praticiens_edit();
				pe.open();
			}
		});
		btnAjouter.setBounds(10, 10, 85, 25);
		btnAjouter.setText("Ajouter");
		
		Button btnDelete = new Button(group, SWT.NONE);
		btnDelete.addSelectionListener(new SelectionAdapter() {
			@Override
			public void widgetSelected(SelectionEvent e) {
				IStructuredSelection sel = (IStructuredSelection) tableViewer.getSelection();
				if(sel != null){
					Praticiens pra = (Praticiens) sel.getFirstElement();
					Session session = HibernateUtil.getSession();
					Transaction tx = session.beginTransaction();
					session.delete(pra);
					tx.commit();
					session.close();
					AppController.initListPraticiens();
					getListInput().remove(pra);
				}
			}
		});
		btnDelete.setBounds(554, 10, 85, 25);
		btnDelete.setText("Delete");
		m_bindingContext = initDataBindings();

	}

	@Override
	protected void checkSubclass() {
		// Disable the check that prevents subclassing of SWT components
	}
	protected DataBindingContext initDataBindings() {
		DataBindingContext bindingContext = new DataBindingContext();
		//
		ObservableListContentProvider listContentProvider = new ObservableListContentProvider();
		IObservableMap[] observeMaps = BeansObservables.observeMaps(listContentProvider.getKnownElements(), Praticiens.class, new String[]{"nom", "prenom", "ville"});
		tableViewer.setLabelProvider(new ObservableMapLabelProvider(observeMaps));
		tableViewer.setContentProvider(listContentProvider);
		//
		selfList = Properties.selfList(Praticiens.class).observe(listPraticiens);
		tableViewer.setInput(selfList);
		//
		ObservableListContentProvider listContentProvider_1 = new ObservableListContentProvider();
		IObservableMap observeMap = BeansObservables.observeMap(listContentProvider_1.getKnownElements(), TypesPraticiens.class, "id");
		comboViewer.setLabelProvider(new ObservableMapLabelProvider(observeMap));
		comboViewer.setContentProvider(listContentProvider_1);
		//
		IObservableList selfList_1 = Properties.selfList(TypesPraticiens.class).observe(listTypesPraticiens);
		comboViewer.setInput(selfList_1);
		//
		return bindingContext;
	}
	
	public IObservableList getListInput(){
		return selfList;
	}
}
