package net.view;

import hibernate.HibernateUtil;

import java.util.ArrayList;
import java.util.List;

import net.controller.AppController;
import net.models.Motifs;
import net.models.Offrirs;
import net.models.Praticiens;
import net.models.Presentations;
import net.models.RapportsVisites;
import net.models.Users;

import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.Label;
import org.eclipse.swt.SWT;
import org.eclipse.swt.widgets.DateTime;
import org.eclipse.swt.widgets.Combo;
import org.eclipse.swt.widgets.Table;
import org.eclipse.swt.widgets.Group;
import org.eclipse.jface.viewers.IStructuredSelection;
import org.eclipse.jface.viewers.TableViewer;
import org.eclipse.jface.viewers.ComboViewer;
import org.eclipse.jface.viewers.TableViewerColumn;
import org.eclipse.core.databinding.DataBindingContext;
import org.eclipse.jface.databinding.viewers.ObservableListContentProvider;
import org.eclipse.core.databinding.observable.map.IObservableMap;
import org.eclipse.core.databinding.beans.BeansObservables;
import org.eclipse.jface.databinding.viewers.ObservableMapLabelProvider;
import org.eclipse.core.databinding.observable.list.IObservableList;
import org.eclipse.core.databinding.property.Properties;
import org.eclipse.swt.widgets.Button;
import org.eclipse.swt.events.SelectionAdapter;
import org.eclipse.swt.events.SelectionEvent;
import org.hibernate.Query;
import org.hibernate.Session;
import org.hibernate.Transaction;

public class RapportsVisites_index extends Composite {
	private DataBindingContext m_bindingContext;
	private Table table;
	private List<Praticiens> listPraticiens = new ArrayList<>();
	private List<Users> listUsers = new ArrayList<>();
	private List<Motifs> listMotifs = new ArrayList<>();
	private List<RapportsVisites> listRapportsVisites = new ArrayList<>();
	private ComboViewer comboViewer;
	private ComboViewer comboViewer_1;
	private ComboViewer comboViewer_2;
	private TableViewer tableViewer;
	public static IObservableList selfList_3;

	/**
	 * Create the composite.
	 * @param parent
	 * @param style
	 */
	public RapportsVisites_index(Composite parent, int style) {
		super(parent, style);
		
		listPraticiens = AppController.getListPraticiens();
		listUsers = AppController.getListUsers();
		listMotifs = AppController.getListMotifs();
		listRapportsVisites = AppController.getListRapportsVisites();
		
		Group grpCritres = new Group(this, SWT.NONE);
		grpCritres.setText("Crit\u00E8res");
		grpCritres.setBounds(10, 10, 237, 130);
		
		Label lblDateDbut = new Label(grpCritres, SWT.NONE);
		lblDateDbut.setBounds(10, 21, 65, 14);
		lblDateDbut.setText("Date Min");
		
		Label lblDateFin = new Label(grpCritres, SWT.NONE);
		lblDateFin.setBounds(10, 41, 59, 14);
		lblDateFin.setText("Date Max");
		
		DateTime dateTime = new DateTime(grpCritres, SWT.BORDER);
		dateTime.setBounds(137, 18, 91, 17);
		
		DateTime dateTime_1 = new DateTime(grpCritres, SWT.BORDER);
		dateTime_1.setBounds(137, 38, 91, 17);
		
		Label lblPraticien = new Label(grpCritres, SWT.NONE);
		lblPraticien.setBounds(10, 61, 59, 14);
		lblPraticien.setText("Praticien");
		
		Label lblVisiteur = new Label(grpCritres, SWT.NONE);
		lblVisiteur.setBounds(10, 81, 59, 14);
		lblVisiteur.setText("Visiteur");
		
		Label lblMotif = new Label(grpCritres, SWT.NONE);
		lblMotif.setBounds(10, 101, 59, 14);
		lblMotif.setText("Motif");
		
		comboViewer = new ComboViewer(grpCritres, SWT.READ_ONLY);
		Combo comboMotif = comboViewer.getCombo();
		comboMotif.setBounds(137, 92, 91, 23);
		
		comboViewer_1 = new ComboViewer(grpCritres, SWT.READ_ONLY);
		Combo comboVisiteur = comboViewer_1.getCombo();
		comboVisiteur.setBounds(137, 72, 91, 23);
		
		comboViewer_2 = new ComboViewer(grpCritres, SWT.READ_ONLY);
		Combo comboPraticien = comboViewer_2.getCombo();
		comboPraticien.setBounds(137, 52, 91, 23);
		
		Group grpRapportsDeVisites = new Group(this, SWT.NONE);
		grpRapportsDeVisites.setText("Rapports de visites");
		grpRapportsDeVisites.setBounds(253, 10, 450, 197);
		
		tableViewer = new TableViewer(grpRapportsDeVisites, SWT.BORDER | SWT.FULL_SELECTION);
		table = tableViewer.getTable();
		table.setBounds(10, 22, 430, 162);
		
		table.setHeaderVisible(true);
		
		TableViewerColumn columnUser = new TableViewerColumn(tableViewer, SWT.NONE);
		TableViewerColumn columnPraticien = new TableViewerColumn(tableViewer, SWT.NONE);
		TableViewerColumn columnMotif = new TableViewerColumn(tableViewer, SWT.NONE);
		TableViewerColumn columnDate = new TableViewerColumn(tableViewer, SWT.NONE);
		
		columnUser.getColumn().setText("Visiteur");
		columnPraticien.getColumn().setText("Praticien");
		columnMotif.getColumn().setText("Motif");
		columnDate.getColumn().setText("Date");
		
		columnUser.getColumn().setWidth(117);
		columnPraticien.getColumn().setWidth(121);
		columnMotif.getColumn().setWidth(104);
		columnDate.getColumn().setWidth(84);
		
		Group group = new Group(this, SWT.NONE);
		group.setBounds(10, 213, 693, 47);
		
		Button btnDelete = new Button(group, SWT.NONE);
		btnDelete.setBounds(598, 12, 85, 25);
		btnDelete.addSelectionListener(new SelectionAdapter() {
			@Override
			public void widgetSelected(SelectionEvent e) {
				IStructuredSelection sel = (IStructuredSelection) tableViewer.getSelection();
				if(sel != null){
					RapportsVisites rv = (RapportsVisites) sel.getFirstElement();
					Session session = HibernateUtil.getSession();
					Transaction tx = session.beginTransaction();
					
					//On supprime les prsentations et les chantillons
					Query query = session.createQuery("from Presentations where rapportsVisites.id="+rv.getId());
					List<Presentations> listPres = query.list();
					for (Presentations presentations : listPres) {
						session.delete(presentations);
					}
					
					query = session.createQuery("from Offrirs where rapportsVisites.id="+rv.getId());
					List<Offrirs> listOffrirs = query.list();
					for (Offrirs offrirs : listOffrirs) {
						session.delete(offrirs);
					}
					
					session.delete(rv);
					tx.commit();
					session.close();
					AppController.initListRapportsVisites();
					getListInput().remove(rv);
				}
			}
		});
		btnDelete.setText("Delete");
		
		m_bindingContext = initDataBindings();

	}

	@Override
	protected void checkSubclass() {
		// Disable the check that prevents subclassing of SWT components
	}
	protected DataBindingContext initDataBindings() {
		DataBindingContext bindingContext = new DataBindingContext();
		//
		ObservableListContentProvider listContentProvider = new ObservableListContentProvider();
		IObservableMap observeMap = BeansObservables.observeMap(listContentProvider.getKnownElements(), Motifs.class, "libelle");
		comboViewer.setLabelProvider(new ObservableMapLabelProvider(observeMap));
		comboViewer.setContentProvider(listContentProvider);
		//
		IObservableList selfList = Properties.selfList(Motifs.class).observe(listMotifs);
		comboViewer.setInput(selfList);
		//
		ObservableListContentProvider listContentProvider_1 = new ObservableListContentProvider();
		IObservableMap[] observeMaps = BeansObservables.observeMaps(listContentProvider_1.getKnownElements(), Users.class, new String[]{"nom", "prenom"});
		comboViewer_1.setLabelProvider(new ObservableMapLabelProvider(observeMaps));
		comboViewer_1.setContentProvider(listContentProvider_1);
		//
		IObservableList selfList_1 = Properties.selfList(Users.class).observe(listUsers);
		comboViewer_1.setInput(selfList_1);
		//
		ObservableListContentProvider listContentProvider_2 = new ObservableListContentProvider();
		IObservableMap[] observeMaps_1 = BeansObservables.observeMaps(listContentProvider_2.getKnownElements(), Praticiens.class, new String[]{"nom", "prenom"});
		comboViewer_2.setLabelProvider(new ObservableMapLabelProvider(observeMaps_1));
		comboViewer_2.setContentProvider(listContentProvider_2);
		//
		IObservableList selfList_2 = Properties.selfList(Praticiens.class).observe(listPraticiens);
		comboViewer_2.setInput(selfList_2);
		//
		ObservableListContentProvider listContentProvider_3 = new ObservableListContentProvider();
		IObservableMap[] observeMaps_2 = BeansObservables.observeMaps(listContentProvider_3.getKnownElements(), RapportsVisites.class, new String[]{"users.nom", "praticiens.nom", "motifs.libelle", "date"});
		tableViewer.setLabelProvider(new ObservableMapLabelProvider(observeMaps_2));
		tableViewer.setContentProvider(listContentProvider_3);
		//
		selfList_3 = Properties.selfList(RapportsVisites.class).observe(listRapportsVisites);
		tableViewer.setInput(selfList_3);
		//
		return bindingContext;
	}
	
	public IObservableList getListInput(){
		return selfList_3;
	}
}
