package net.view;

import hibernate.HibernateUtil;

import java.util.ArrayList;
import java.util.List;

import net.controller.AppController;
import net.gui.MainWindow;
import net.gui.Visiteurs_edit;
import net.models.Groups;
import net.models.Users;

import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.Label;
import org.eclipse.swt.SWT;
import org.eclipse.swt.widgets.MessageBox;
import org.eclipse.swt.widgets.Table;
import org.eclipse.swt.widgets.Combo;
import org.eclipse.swt.widgets.Group;
import org.eclipse.swt.widgets.Button;
import org.eclipse.wb.swt.SWTResourceManager;
import org.eclipse.swt.events.SelectionAdapter;
import org.eclipse.swt.events.SelectionEvent;
import org.eclipse.jface.viewers.ComboViewer;
import org.eclipse.jface.viewers.IStructuredSelection;
import org.eclipse.jface.viewers.StructuredSelection;
import org.eclipse.jface.viewers.TableViewer;
import org.eclipse.jface.viewers.TableViewerColumn;
import org.eclipse.core.databinding.DataBindingContext;
import org.eclipse.jface.databinding.viewers.ObservableListContentProvider;
import org.eclipse.core.databinding.observable.map.IObservableMap;
import org.eclipse.core.databinding.beans.BeansObservables;
import org.eclipse.jface.databinding.viewers.ObservableMapLabelProvider;
import org.eclipse.core.databinding.observable.list.IObservableList;
import org.eclipse.core.databinding.property.Properties;
import org.hibernate.Query;
import org.hibernate.Session;
import org.hibernate.Transaction;
import org.hibernate.mapping.Array;
import org.eclipse.swt.events.MouseAdapter;
import org.eclipse.swt.events.MouseEvent;

public class Visiteurs_index extends Composite {
	private DataBindingContext m_bindingContext;
	private Table table;
	private List<Groups> listGroups = new ArrayList<>();
	private List<Users> listUsers = new ArrayList<>();
	private ComboViewer comboViewer;
	private TableViewer tableViewer;
	public static IObservableList selfList;

	/**
	 * Create the composite.
	 * @param parent
	 * @param style
	 */
	public Visiteurs_index(Composite parent, int style) {
		super(parent, style);
		
		listGroups = AppController.getListGroups();
		listUsers = AppController.getListUsers();
		
		Group grpVisiteurs = new Group(this, SWT.NONE);
		grpVisiteurs.setText("Groupe");
		grpVisiteurs.setBounds(10, 10, 178, 54);

		Group grpListeDesVisiteurs = new Group(this, SWT.NONE);
		grpListeDesVisiteurs.setText("Visiteurs");
		grpListeDesVisiteurs.setBounds(194, 10, 466, 188);

		tableViewer = new TableViewer(grpListeDesVisiteurs, SWT.BORDER | SWT.FULL_SELECTION);
		table = tableViewer.getTable();
		table.setBounds(10, 22, 446, 156);
		
		comboViewer = new ComboViewer(grpVisiteurs, SWT.READ_ONLY);
		Combo combo = comboViewer.getCombo();
		combo.addSelectionListener(new SelectionAdapter() {
			@Override
			public void widgetSelected(SelectionEvent e) {
				IStructuredSelection sel = (IStructuredSelection) comboViewer.getSelection();
				Groups selectedGroup = (Groups) sel.getFirstElement();
				List<Users> elementsASuppr = new ArrayList<>();
				for (Users users : listUsers) {
					if(!users.getGroups().equals(selectedGroup)){
						elementsASuppr.add(users);
					}
				}
				while(elementsASuppr.size()!=0){
					listUsers.remove(elementsASuppr.get(0));
					elementsASuppr.remove(0);
				}
				tableViewer.refresh();
			}
		});
		combo.setBounds(10, 21, 158, 23);
		
		table.setHeaderVisible(true);
		
		TableViewerColumn columnNom = new TableViewerColumn(tableViewer, SWT.NONE);
		TableViewerColumn columnPrenom = new TableViewerColumn(tableViewer, SWT.NONE);
		TableViewerColumn columnVille = new TableViewerColumn(tableViewer, SWT.NONE);
		
		columnNom.getColumn().setText("Nom");
		columnPrenom.getColumn().setText("Prenom");
		columnVille.getColumn().setText("Ville");
		
		columnNom.getColumn().setWidth(164);
		columnPrenom.getColumn().setWidth(130);
		columnVille.getColumn().setWidth(127);
		
		Group group = new Group(this, SWT.NONE);
		group.setBounds(10, 203, 650, 47);
		
		Button btnAjotuer = new Button(group, SWT.NONE);
		btnAjotuer.addSelectionListener(new SelectionAdapter() {
			@Override
			public void widgetSelected(SelectionEvent e) {
				Visiteurs_edit ve = new Visiteurs_edit();
				ve.open();
			}
		});
		btnAjotuer.setBounds(10, 10, 85, 27);
		btnAjotuer.setText("Ajouter");
		
		Button btnDelete = new Button(group, SWT.NONE);
		btnDelete.addSelectionListener(new SelectionAdapter() {
			@Override
			public void widgetSelected(SelectionEvent e) {
				IStructuredSelection sel = (IStructuredSelection) tableViewer.getSelection();
				if(sel != null){
					Users user = (Users) sel.getFirstElement();
					Session session = HibernateUtil.getSession();
					Transaction tx = session.beginTransaction();
					session.delete(user);
					tx.commit();
					session.close();
					AppController.initListUsers();
					getListInput().remove(user);
				}
			}
		});
		btnDelete.setBounds(555, 10, 85, 27);
		btnDelete.setText("Delete");
		m_bindingContext = initDataBindings();

	}

	@Override
	protected void checkSubclass() {
		// Disable the check that prevents subclassing of SWT components
	}
	protected DataBindingContext initDataBindings() {
		DataBindingContext bindingContext = new DataBindingContext();
		//
		ObservableListContentProvider listContentProvider = new ObservableListContentProvider();
		IObservableMap observeMap = BeansObservables.observeMap(listContentProvider.getKnownElements(), Groups.class, "name");
		comboViewer.setLabelProvider(new ObservableMapLabelProvider(observeMap));
		comboViewer.setContentProvider(listContentProvider);
		//
		selfList = Properties.selfList(Groups.class).observe(listGroups);
		comboViewer.setInput(selfList);
		//
		ObservableListContentProvider listContentProvider_1 = new ObservableListContentProvider();
		IObservableMap[] observeMaps = BeansObservables.observeMaps(listContentProvider_1.getKnownElements(), Users.class, new String[]{"nom", "prenom", "ville"});
		tableViewer.setLabelProvider(new ObservableMapLabelProvider(observeMaps));
		tableViewer.setContentProvider(listContentProvider_1);
		//
		IObservableList selfList_1 = Properties.selfList(Users.class).observe(listUsers);
		tableViewer.setInput(selfList_1);
		//
		
//		if (!listGroups.isEmpty()) {
//			comboViewer.setSelection(new StructuredSelection(listGroups.get(0)));
//		}
		
		return bindingContext;
	}
	
	public IObservableList getListInput(){
		return selfList;
	}
}
